// DO_WriteValueDlg.cpp : implementation file
//

#include "stdafx.h"
#include "math.h"
#include "DO_WriteValue.h"
#include "DO_WriteValueDlg.h"
#include "..\..\..\Includes\ICPDAS_USBIO.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

ICPDAS_USBIO USBIO;
BYTE m_byDITotal;
BYTE m_byDOTotal;
BYTE m_byAITotal;
BYTE m_byAOTotal;
BYTE m_byPITotal;
BYTE m_byPOTotal;

/////////////////////////////////////////////////////////////////////////////
// CDO_WriteValueDlg dialog

CDO_WriteValueDlg::CDO_WriteValueDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDO_WriteValueDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDO_WriteValueDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDO_WriteValueDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDO_WriteValueDlg)
	DDX_Control(pDX, IDC_TXTWRDOVALUE, m_txtWrDOValue);
	DDX_Control(pDX, IDC_TXTRDDOVALUE, m_txtRdDOValue);
	DDX_Control(pDX, IDC_BTNWRITE, m_btnWrite);
	DDX_Control(pDX, IDC_BTNREAD, m_btnRead);
	DDX_Control(pDX, IDC_TXTBOARDID, m_txtBID);
	DDX_Control(pDX, IDC_LBINFORMATION, m_lbModuleInfo);
	DDX_Control(pDX, IDC_CBXDEVID, m_cbxDID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDO_WriteValueDlg, CDialog)
	//{{AFX_MSG_MAP(CDO_WriteValueDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTNOPEN, OnOpenDevice)
	ON_BN_CLICKED(IDC_BTNCLOSE, OnCloseDevice)
	ON_BN_CLICKED(IDC_BTNREAD, OnBtnReadClick)
	ON_BN_CLICKED(IDC_BTNWRITE, OnBtnWirteClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDO_WriteValueDlg message handlers

BOOL CDO_WriteValueDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
  // TODO: Add extra initialization here
  m_txtBID.SetWindowText("1");
  m_cbxDID.SetCurSel(0);
  m_txtRdDOValue.SetWindowText("0");
  m_txtWrDOValue.SetWindowText("0");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDO_WriteValueDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDO_WriteValueDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDO_WriteValueDlg::OnOpenDevice() 
{
  CString szBID;
  DWORD dwBID;
  int iSelIdx;
  int iModuleID;
  int iErrCode;
  
  m_txtBID.GetWindowText(szBID);
  dwBID = _tcstoul(szBID, NULL, 10);
  
  iSelIdx = m_cbxDID.GetCurSel();

  switch (iSelIdx)
  {
  case 0:
	  iModuleID = USB2026;
	  break;
  case 1:
      iModuleID = USB2045;
	  break;
  case 2:
      iModuleID = USB2055;
	  break;
  case 3:
      iModuleID = USB2060;
	  break;
  case 4:
	  iModuleID = USB2064;
	  break;
  case 5:
	  iModuleID = USB2045_32;
	  break;
  case 6:
	  iModuleID = USB2055_32;
	  break;
  case 7:
	  iModuleID = USB2064_16;
	  break;
  case 8:
	  iModuleID = USB2068_18;
	  break;
  case 9:
	  iModuleID = USB2255_32;
    break;
  case 10:
	  iModuleID = USB2255_64;
	  break;
	  case 11:
	  iModuleID = USB2261_16;
	  break;
case 12:
	  iModuleID = USB2261_32;
	  break;
case 13:
	iModuleID = USB2260_48;
	break;
case 14:
	iModuleID = USB2260B_48;
	break;
case 15:
	iModuleID = USB2260C_48;
	break;
case 16:
	iModuleID = USB2260_24;
	break;
case 17:
	iModuleID = USB2260B_24;
	break;
case 18:
	iModuleID = USB2260C_24;
	break;
  }
  USBIO.SetCommTimeout(500);
  if(ERR_NO_ERR != (iErrCode = USBIO.OpenDevice(iModuleID, (BYTE)dwBID)))
  {
    char szMessage[10];
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    DWORD dwSoftWDTTimeout;
    WORD wFWVer;
    BYTE byDeviceSN[USBIO_SN_LENGTH];
    BYTE byDeviceNickName[USBIO_NICKNAME_LENGTH];
    BYTE bySupIOMask;
    int iIdx;
    
    USBIO.GetSoftWDTTimeout(&dwSoftWDTTimeout);
    sprintf(szItemString, "SoftWDT: %d", dwSoftWDTTimeout);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetFwVer(&wFWVer);
    sprintf(szItemString, "Version: %d", wFWVer);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetDeviceNickName(byDeviceNickName);
    sprintf(szItemString, "Description: ");
    for(iIdx = 0; iIdx < USBIO_NICKNAME_LENGTH; iIdx++)
      sprintf(szItemString + strlen(szItemString), "%c", byDeviceNickName[iIdx]);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetDeviceSN(byDeviceSN);
    sprintf(szItemString, "SN: ");
    for(iIdx = 0; iIdx < USBIO_SN_LENGTH; iIdx++)
      sprintf(szItemString + strlen(szItemString), "%C", byDeviceSN[iIdx]);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetSupportIOMask(&bySupIOMask);
    sprintf(szItemString, "Support IO Mask: 0x%02X", bySupIOMask);
    m_lbModuleInfo.AddString(szItemString);
    
    if(SUPPORT_DI(bySupIOMask))
    {
      USBIO.GetDITotal(&m_byDITotal);
      sprintf(szItemString, "DI channels: %d", m_byDITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_DO(bySupIOMask))
    {
      USBIO.GetDOTotal(&m_byDOTotal);
      sprintf(szItemString, "DO channels: %d", m_byDOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_AI(bySupIOMask))
    {
      USBIO.GetAITotal(&m_byAITotal);
      sprintf(szItemString, "AI channels: %d", m_byAITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_AO(bySupIOMask))
    {
      USBIO.GetAOTotal(&m_byAOTotal);
      sprintf(szItemString, "AO channels: %d", m_byAOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_PI(bySupIOMask))
    {
      USBIO.GetPITotal(&m_byPITotal);
      sprintf(szItemString, "PI channels: %d", m_byPITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_PO(bySupIOMask))
    {
      USBIO.GetPOTotal(&m_byPOTotal);
      sprintf(szItemString, "PO channels: %d", m_byPOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    m_btnRead.EnableWindow(TRUE);
    m_btnWrite.EnableWindow(TRUE);
    m_txtWrDOValue.EnableWindow(TRUE);
  }
}

void CDO_WriteValueDlg::OnCloseDevice() 
{
  int iErrCode;
  
  if(ERR_NO_ERR != (iErrCode = USBIO.CloseDevice()))
  {
    char szMessage[10];
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  
  m_btnRead.EnableWindow(FALSE);
  m_btnWrite.EnableWindow(FALSE);
  m_txtWrDOValue.EnableWindow(FALSE);
  
  m_lbModuleInfo.ResetContent();
}

void CDO_WriteValueDlg::OnBtnReadClick() 
{
  int iErrCode;
  BYTE o_byDOValue[(USBIO_DO_MAX_CHANNEL + 7) >> 3];
  char szMessage[300] = {NULL};

  if(ERR_NO_ERR != (iErrCode = USBIO.DO_ReadValue(o_byDOValue)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    for(int iIdx = 0; iIdx < ((m_byDOTotal + 7) / 8); iIdx++)
      sprintf(szMessage + strlen(szMessage) , "%02X", o_byDOValue[((m_byDOTotal + 7) / 8) -1 - iIdx]);

    m_txtRdDOValue.SetWindowText(szMessage);
  }
}

void CDO_WriteValueDlg::OnBtnWirteClick() 
{
  int iErrCode;
  char szMessage[300];
  DWORD dwDOValue;
  CString szDOValue;
  BYTE i_byDOValue[(USBIO_DO_MAX_CHANNEL + 7) / 8];
  int iIdx;
  
  m_txtWrDOValue.GetWindowText(szDOValue);
  dwDOValue = _tcstoul(szDOValue, NULL, 16);
  
  if(dwDOValue > pow(2, m_byDOTotal))
  {
    sprintf(szMessage, "Invalid DO value");
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
    
    return;
  }

  for(iIdx = 0; iIdx < (m_byDOTotal + 7) / 8; iIdx++)
    i_byDOValue[iIdx] = (BYTE)((dwDOValue >> (iIdx * 8)) & 0xFF);
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DO_WriteValue(i_byDOValue)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    MessageBox("Success.", "Error", MB_ICONINFORMATION | MB_OK);
  }
}
